diff --git a/web/pgadmin/browser/server_groups/servers/databases/schemas/domains/tests/test_domain_get_types_func.py b/web/pgadmin/browser/server_groups/servers/databases/schemas/domains/tests/test_domain_get_types_func.py
new file mode 100644
index 000000000..8c4fa016d
--- /dev/null
+++ b/web/pgadmin/browser/server_groups/servers/databases/schemas/domains/tests/test_domain_get_types_func.py
@@ -0,0 +1,89 @@
+##########################################################################
+#
+# pgAdmin 4 - PostgreSQL Tools
+#
+# Copyright (C) 2013 - 2020, The pgAdmin Development Team
+# This software is released under the PostgreSQL Licence
+#
+##########################################################################
+
+import json
+import uuid
+
+from pgadmin.browser.server_groups.servers.databases.schemas.tests import \
+    utils as schema_utils
+from pgadmin.browser.server_groups.servers.databases.tests import utils as \
+    database_utils
+from pgadmin.utils.route import BaseTestGenerator
+from regression import parent_node_dict
+from regression.python_test_utils import test_utils as utils
+from . import utils as domain_utils
+from unittest.mock import patch
+
+
+class DomainGetTypesTestCase(BaseTestGenerator):
+    """ This class will add new domain under schema node. """
+
+    # scenarios = [
+    #     # Fetching default URL for domain node.
+    #     ('Fetch domain Node URL', dict(url='/browser/domain/obj/'))
+    # ]
+    scenarios = utils.generate_scenarios('domain_get_types',
+                                         domain_utils.test_cases)
+
+    def setUp(self):
+        super(DomainGetTypesTestCase, self).setUp()
+        self.db_name = parent_node_dict["database"][-1]["db_name"]
+        schema_info = parent_node_dict["schema"][-1]
+        self.server_id = schema_info["server_id"]
+        self.db_id = schema_info["db_id"]
+        self.schema_id = schema_info["schema_id"]
+        self.schema_name = schema_info["schema_name"]
+        self.domain_name = "domain_get_%s" % (str(uuid.uuid4())[1:8])
+        self.domain_info = domain_utils.create_domain(self.server,
+                                                      self.db_name,
+                                                      self.schema_name,
+                                                      self.schema_id,
+                                                      self.domain_name)
+
+    def get_types(self):
+        """
+        This function returns domain types
+        :return: created domain response
+        """
+        return self.tester.get(
+            self.url + str(utils.SERVER_GROUP) + '/' +
+            str(self.server_id) + '/' +
+            str(self.db_id) + '/' +
+            str(self.schema_id) + '/',
+            follow_redirects=True)
+
+    def runTest(self):
+        """ This function will add domain under schema node. """
+        db_con = database_utils.connect_database(self, utils.SERVER_GROUP,
+                                                 self.server_id, self.db_id)
+        if not db_con['data']["connected"]:
+            raise Exception("Could not connect to database to add domain.")
+        schema_response = schema_utils.verify_schemas(self.server,
+                                                      self.db_name,
+                                                      self.schema_name)
+        if not schema_response:
+            raise Exception("Could not find the schema to add the domain.")
+
+        if self.is_positive_test:
+            response = self.get_types()
+
+        else:
+            if hasattr(self, "internal_server_error"):
+                return_value_object = eval(self.mock_data["return_value"])
+                with patch(self.mock_data["function_name"],
+                           side_effect=[return_value_object]):
+                    response = self.get_types()
+
+        expected_response_code = self.expected_data['status_code']
+
+        self.assertEquals(response.status_code, expected_response_code)
+
+    def tearDown(self):
+        # Disconnect the database
+        database_utils.disconnect_database(self, self.server_id, self.db_id)
diff --git a/web/pgadmin/browser/server_groups/servers/databases/schemas/domains/tests/test_domain_msql.py b/web/pgadmin/browser/server_groups/servers/databases/schemas/domains/tests/test_domain_msql.py
new file mode 100644
index 000000000..16972ae30
--- /dev/null
+++ b/web/pgadmin/browser/server_groups/servers/databases/schemas/domains/tests/test_domain_msql.py
@@ -0,0 +1,81 @@
+##########################################################################
+#
+# pgAdmin 4 - PostgreSQL Tools
+#
+# Copyright (C) 2013 - 2020, The pgAdmin Development Team
+# This software is released under the PostgreSQL Licence
+#
+##########################################################################
+
+import uuid
+import json
+import re
+
+from pgadmin.browser.server_groups.servers.databases.schemas.tests import \
+    utils as schema_utils
+from pgadmin.browser.server_groups.servers.databases.tests import utils as \
+    database_utils
+from pgadmin.utils.route import BaseTestGenerator
+from regression import parent_node_dict
+from regression.python_test_utils import test_utils as utils
+from . import utils as domain_utils
+from unittest.mock import patch
+
+
+class DomainMsqlTestCase(BaseTestGenerator):
+    """ This class will delete new domain under schema node. """
+    scenarios = utils.generate_scenarios('domain_get_msql',
+                                         domain_utils.test_cases)
+
+    def setUp(self):
+        self.database_info = parent_node_dict["database"][-1]
+        self.db_name = self.database_info["db_name"]
+        self.db_id = self.database_info["db_id"]
+        self.server_id = self.database_info["server_id"]
+        self.schema_info = parent_node_dict["schema"][-1]
+        self.schema_name = self.schema_info["schema_name"]
+        self.schema_id = self.schema_info["schema_id"]
+        self.domain_name = "domain_delete_%s" % (str(uuid.uuid4())[1:8])
+        self.domain_info = domain_utils.create_domain(self.server,
+                                                      self.db_name,
+                                                      self.schema_name,
+                                                      self.schema_id,
+                                                      self.domain_name)
+
+    def msql_domain(self):
+        """
+        This function returns the domain msql response
+        :return: domain msql response
+        """
+        return self.tester.get(
+            self.url + str(utils.SERVER_GROUP) + '/' +
+            str(self.server_id) + '/' +
+            str(self.db_id) + '/' +
+            str(self.schema_id) + '/' +
+            str(self.domain_id),
+            follow_redirects=True)
+
+    def runTest(self):
+        db_con = database_utils.connect_database(self, utils.SERVER_GROUP,
+                                                 self.server_id, self.db_id)
+        if not db_con['data']["connected"]:
+            raise Exception("Could not connect to database to add domain.")
+        schema_response = schema_utils.verify_schemas(self.server,
+                                                      self.db_name,
+                                                      self.schema_name)
+        if not schema_response:
+            raise Exception("Could not find the schema to add the domain.")
+        self.domain_id = self.domain_info[0]
+
+        if self.is_positive_test:
+            with patch(self.mock_data["function_name"],
+                       return_value=eval(self.mock_data["return_value"])):
+                response = self.msql_domain()
+                actual_response_code = response.status_code
+                expected_response_code = self.expected_data['status_code']
+
+        self.assertEquals(actual_response_code, expected_response_code)
+
+    def tearDown(self):
+        # Disconnect the database
+        database_utils.disconnect_database(self, self.server_id, self.db_id)
diff --git a/web/pgadmin/browser/server_groups/servers/databases/schemas/domains/tests/test_domain_put.py b/web/pgadmin/browser/server_groups/servers/databases/schemas/domains/tests/test_domain_put.py
index 2701a9c16..aafd0ba45 100644
--- a/web/pgadmin/browser/server_groups/servers/databases/schemas/domains/tests/test_domain_put.py
+++ b/web/pgadmin/browser/server_groups/servers/databases/schemas/domains/tests/test_domain_put.py
@@ -18,17 +18,18 @@ from pgadmin.utils.route import BaseTestGenerator
 from regression import parent_node_dict
 from regression.python_test_utils import test_utils as utils
 from . import utils as domain_utils
+from unittest.mock import patch
 
 
 class DomainPutTestCase(BaseTestGenerator):
-    """ This class will fetch new collation under schema node. """
-    scenarios = [
-        # Fetching default URL for domain node.
-        ('Fetch domain Node URL', dict(url='/browser/domain/obj/'))
-    ]
+    """ This class will fetch new domain under schema node. """
+    scenarios = utils.generate_scenarios('domain_update',
+                                         domain_utils.test_cases)
 
     def setUp(self):
         self.database_info = parent_node_dict["database"][-1]
+        self.db_id = self.database_info["db_id"]
+        self.server_id = self.database_info["server_id"]
         self.db_name = self.database_info["db_name"]
         self.schema_info = parent_node_dict["schema"][-1]
         self.schema_name = self.schema_info["schema_name"]
@@ -40,12 +41,24 @@ class DomainPutTestCase(BaseTestGenerator):
                                                       self.schema_id,
                                                       self.domain_name)
 
+    def update_domain(self):
+        """
+        This functions update domain  details
+        :return: Domain update request details
+        """
+        return self.tester.put(
+            self.url + str(utils.SERVER_GROUP) + '/' +
+            str(self.server_id) + '/' +
+            str(self.db_id) + '/' +
+            str(self.schema_id) + '/' +
+            str(self.domain_id),
+            data=json.dumps(self.test_data),
+            follow_redirects=True)
+
     def runTest(self):
         """ This function will update domain under schema node. """
-        db_id = self.database_info["db_id"]
-        server_id = self.database_info["server_id"]
         db_con = database_utils.connect_database(self, utils.SERVER_GROUP,
-                                                 server_id, db_id)
+                                                 self.server_id, self.db_id)
         if not db_con['data']["connected"]:
             raise Exception("Could not connect to database to get the domain.")
         db_name = self.database_info["db_name"]
@@ -60,21 +73,27 @@ class DomainPutTestCase(BaseTestGenerator):
                                                      self.domain_name)
         if not domain_response:
             raise Exception("Could not find the domain to update.")
-        domain_id = self.domain_info[0]
-        data = {"description": "This is domain update comment",
-                "id": domain_id,
-                }
-        response = self.tester.put(
-            self.url + str(utils.SERVER_GROUP) + '/' +
-            str(server_id) + '/' +
-            str(db_id) + '/' +
-            str(self.schema_id) + '/' +
-            str(domain_id),
-            data=json.dumps(data),
-            follow_redirects=True)
-        self.assertEquals(response.status_code, 200)
-        # Disconnect the database
-        database_utils.disconnect_database(self, server_id, db_id)
+        self.domain_id = self.domain_info[0]
+        self.test_data['id'] = self.domain_id
+
+        if self.is_positive_test:
+            response = self.update_domain()
+        else:
+            if hasattr(self, "error_updating_domain"):
+                return_value_object = eval(self.mock_data["return_value"])
+                with patch(self.mock_data["function_name"],
+                           side_effect=[return_value_object]):
+                    response = self.update_domain()
+
+            if hasattr(self, "error_in_db"):
+                with patch(self.mock_data["function_name"],
+                           side_effect=eval(self.mock_data["return_value"])):
+                    response = self.update_domain()
+
+        actual_response_code = response.status_code
+        expected_response_code = self.expected_data['status_code']
+        self.assertEquals(actual_response_code, expected_response_code)
 
     def tearDown(self):
-        pass
+        # Disconnect the database
+        database_utils.disconnect_database(self, self.server_id, self.db_id)
diff --git a/web/pgadmin/browser/server_groups/servers/databases/schemas/domains/tests/test_domain_sql.py b/web/pgadmin/browser/server_groups/servers/databases/schemas/domains/tests/test_domain_sql.py
index 8f106dbd0..ffe4a11dc 100644
--- a/web/pgadmin/browser/server_groups/servers/databases/schemas/domains/tests/test_domain_sql.py
+++ b/web/pgadmin/browser/server_groups/servers/databases/schemas/domains/tests/test_domain_sql.py
@@ -19,32 +19,14 @@ from pgadmin.utils.route import BaseTestGenerator
 from regression import parent_node_dict
 from regression.python_test_utils import test_utils as utils
 from . import utils as domain_utils
+from unittest.mock import patch
 
 
 class DomainReverseEngineeredSQLTestCase(BaseTestGenerator):
     """ This class will verify reverse engineered sql for domain
      under schema node. """
-    scenarios = [
-        # Fetching default URL for domain node.
-        ('Domain Reverse Engineered SQL with char',
-         dict(url='/browser/domain/sql/',
-              domain_name='domain_get_%s' % (str(uuid.uuid4())[1:8]),
-              domain_sql='AS "char";'
-              )
-         ),
-        ('Domain Reverse Engineered SQL with Length, Precision and Default',
-         dict(url='/browser/domain/sql/',
-              domain_name='domain_get_%s' % (str(uuid.uuid4())[1:8]),
-              domain_sql='AS numeric(12,2) DEFAULT 12 NOT NULL;'
-              )
-         ),
-        ('Domain Reverse Engineered SQL with Length',
-         dict(url='/browser/domain/sql/',
-              domain_name='domain_get_%s' % (str(uuid.uuid4())[1:8]),
-              domain_sql='AS interval(6);'
-              )
-         ),
-    ]
+    scenarios = utils.generate_scenarios('domain_get_sql',
+                                         domain_utils.test_cases)
 
     def setUp(self):
         self.database_info = parent_node_dict["database"][-1]
@@ -52,20 +34,51 @@ class DomainReverseEngineeredSQLTestCase(BaseTestGenerator):
         self.schema_info = parent_node_dict["schema"][-1]
         self.schema_name = self.schema_info["schema_name"]
         self.schema_id = self.schema_info["schema_id"]
-        self.domain_info = domain_utils.create_domain(self.server,
-                                                      self.db_name,
-                                                      self.schema_name,
-                                                      self.schema_id,
-                                                      self.domain_name,
-                                                      self.domain_sql)
+        self.test_data['domain_name'] = 'domain_get_%s' % (
+                                        str(uuid.uuid4())[1:8])
+        if hasattr(self, "Domain_Reverse_Engineered_SQL_with_char"):
+            self.test_data['domain_sql'] = 'AS "char";'
+
+        if hasattr(self,
+           "Domain_Reverse_Engineered_SQL_with_Length_Precision_and_Default"):
+            self.test_data['domain_sql'] =\
+                'AS numeric(12,2) DEFAULT 12 NOT NULL;'
+
+        if hasattr(self, "Domain_Reverse_Engineered_SQL_with_Length"):
+            self.test_data['domain_sql'] = 'AS interval(6);'
+        if hasattr(self, "internal_server_error"):
+            self.test_data['domain_sql'] = 'AS "char";'
+        if hasattr(self, "wrong_domain_id"):
+            self.test_data['domain_sql'] = 'AS "char";'
+
+        self.domain_info =\
+            domain_utils.create_domain(self.server,
+                                       self.db_name,
+                                       self.schema_name,
+                                       self.schema_id,
+                                       self.test_data['domain_name'],
+                                       self.test_data['domain_sql'])
+
+    def get_sql(self):
+        """
+        This function returns the doamin sql
+        :return: domain sql
+        """
+        return self.tester.get(
+            self.url + str(utils.SERVER_GROUP) + '/' +
+            str(self.server_id) + '/' +
+            str(self.db_id) + '/' +
+            str(self.schema_id) + '/' +
+            str(self.domain_id),
+            content_type='html/json')
 
     def runTest(self):
         """ This function will add domain and verify the
          reverse engineered sql. """
-        db_id = self.database_info["db_id"]
-        server_id = self.database_info["server_id"]
+        self.db_id = self.database_info["db_id"]
+        self.server_id = self.database_info["server_id"]
         db_con = database_utils.connect_database(self, utils.SERVER_GROUP,
-                                                 server_id, db_id)
+                                                 self.server_id, self.db_id)
         if not db_con['data']["connected"]:
             raise Exception("Could not connect to database to get the domain.")
 
@@ -75,44 +88,57 @@ class DomainReverseEngineeredSQLTestCase(BaseTestGenerator):
                                                       self.schema_name)
         if not schema_response:
             raise Exception("Could not find the schema to get the domain.")
-        domain_id = self.domain_info[0]
+        self.domain_id = self.domain_info[0]
 
         # Call GET API to fetch the domain sql
-        get_response = self.tester.get(
-            self.url + str(utils.SERVER_GROUP) + '/' +
-            str(server_id) + '/' +
-            str(db_id) + '/' +
-            str(self.schema_id) + '/' +
-            str(domain_id),
-            content_type='html/json')
-
-        self.assertEquals(get_response.status_code, 200)
-        orig_sql = json.loads(get_response.data.decode('utf-8'))
-
-        # Replace multiple spaces with one space and check the expected sql
-        sql = re.sub('\s+', ' ', orig_sql).strip()
-        expected_sql = '-- DOMAIN: {0}.{1} -- DROP DOMAIN {0}.{1}; ' \
-                       'CREATE DOMAIN {0}.{1} {2} ' \
-                       'ALTER DOMAIN {0}.{1} OWNER' \
-                       ' TO {3};'.format(self.schema_name,
-                                         self.domain_name,
-                                         self.domain_sql,
-                                         self.server["username"])
-
-        self.assertEquals(sql, expected_sql)
-
-        domain_utils.delete_domain(self.server, db_name,
-                                   self.schema_name, self.domain_name)
-
-        # Verify the reverse engineered sql with creating domain with
-        # the sql we get from the server
-        domain_utils.create_domain_from_sql(self.server, db_name, orig_sql)
-
-        domain_utils.delete_domain(self.server, db_name,
-                                   self.schema_name, self.domain_name)
-
-        # Disconnect the database
-        database_utils.disconnect_database(self, server_id, db_id)
+        if self.is_positive_test:
+            get_response = self.get_sql()
+
+            expected_response_code = self.expected_data['status_code']
+            self.assertEquals(get_response.status_code, expected_response_code)
+            orig_sql = json.loads(get_response.data.decode('utf-8'))
+
+            # Replace multiple spaces with one space and check the expected sql
+            sql = re.sub('\s+', ' ', orig_sql).strip()
+            expected_sql = '-- DOMAIN: {0}.{1} -- DROP DOMAIN {0}.{1}; ' \
+                           'CREATE DOMAIN {0}.{1} {2} ' \
+                           'ALTER DOMAIN {0}.{1} OWNER' \
+                           ' TO {3};'.format(self.schema_name,
+                                             self.test_data['domain_name'],
+                                             self.test_data['domain_sql'],
+                                             self.server["username"])
+
+            self.assertEquals(sql, expected_sql)
+
+            domain_utils.delete_domain(self.server,
+                                       db_name,
+                                       self.schema_name,
+                                       self.test_data['domain_name'])
+
+            # Verify the reverse engineered sql with creating domain with
+            # the sql we get from the server
+            domain_utils.create_domain_from_sql(self.server, db_name, orig_sql)
+
+            domain_utils.delete_domain(self.server, db_name,
+                                       self.schema_name,
+                                       self.test_data['domain_name'])
+        else:
+            if hasattr(self, "internal_server_error"):
+                with patch(self.mock_data["function_name"],
+                           return_value=eval(self.mock_data["return_value"])):
+                    get_response = self.get_sql()
+
+                    expected_response_code = self.expected_data['status_code']
+                    self.assertEquals(get_response.status_code,
+                                      expected_response_code)
+
+            if hasattr(self, "wrong_domain_id"):
+                self.domain_id = 99999
+                get_response = self.get_sql()
+                expected_response_code = self.expected_data['status_code']
+                self.assertEquals(get_response.status_code,
+                                  expected_response_code)
 
     def tearDown(self):
-        pass
+        # Disconnect the database
+        database_utils.disconnect_database(self, self.server_id, self.db_id)
diff --git a/web/pgadmin/browser/server_groups/servers/databases/schemas/domains/tests/utils.py b/web/pgadmin/browser/server_groups/servers/databases/schemas/domains/tests/utils.py
index 342bd6552..84a9169b9 100644
--- a/web/pgadmin/browser/server_groups/servers/databases/schemas/domains/tests/utils.py
+++ b/web/pgadmin/browser/server_groups/servers/databases/schemas/domains/tests/utils.py
@@ -11,9 +11,14 @@ from __future__ import print_function
 
 import sys
 import traceback
-
+import os
+import json
 from regression.python_test_utils import test_utils as utils
 
+CURRENT_PATH = os.path.dirname(os.path.realpath(__file__))
+with open(CURRENT_PATH + "/domain_test_data.json") as data_file:
+    test_cases = json.load(data_file)
+
 
 def create_domain(server, db_name, schema_name, schema_id, domain_name,
                   domain_sql=None):
